diff --git a/strongswan-5.2.0/Makefile.am b/strongswan-5.2.0/Makefile.am
index 0703abc..15c71f9 100644
--- a/strongswan-5.2.0/Makefile.am
+++ b/strongswan-5.2.0/Makefile.am
@@ -1,4 +1,4 @@
-SUBDIRS = src man conf init testing
+SUBDIRS = src man conf init
 
 if USE_SCRIPTS
   SUBDIRS += scripts
@@ -10,11 +10,6 @@ endif
 
 ACLOCAL_AMFLAGS = -I m4/config
 
-EXTRA_DIST = Doxyfile.in LICENSE Android.common.mk.in Android.common.mk Android.mk
-CLEANFILES = Doxyfile
-BUILT_SOURCES = Android.common.mk
-MAINTAINERCLEANFILES = Android.common.mk
-
 if USE_DEV_HEADERS
 config_includedir = $(ipseclibdir)/include
 nodist_config_include_HEADERS = config.h
@@ -23,23 +18,6 @@ endif
 # we leave config files behind intentionally so prevent distcheck from complaining
 distuninstallcheck_listfiles = find . -type f \! -name '*.conf' -print
 
-Android.common.mk :	Android.common.mk.in configure.ac
-		$(AM_V_GEN) \
-		sed \
-		-e "s:\@PACKAGE_VERSION\@:$(PACKAGE_VERSION):" \
-		$(srcdir)/$@.in > $@
-
-Doxyfile :	Doxyfile.in
-		$(AM_V_GEN) \
-		sed \
-		-e "s:\@PACKAGE_VERSION\@:$(PACKAGE_VERSION):" \
-		-e "s:\@PACKAGE_NAME\@:$(PACKAGE_NAME):" \
-		-e "s:\@SRC_DIR\@:$(srcdir):" \
-		$(srcdir)/$@.in > $@
-
-apidoc :	Doxyfile
-		doxygen
-
 cov-reset-common:
 		@rm -rf $(top_builddir)/coverage
 		@find $(top_builddir)/src $(top_builddir)/scripts -name "*.gcda" -delete
diff --git a/strongswan-5.2.0/conf/Makefile.am b/strongswan-5.2.0/conf/Makefile.am
index 373be16..7745435 100644
--- a/strongswan-5.2.0/conf/Makefile.am
+++ b/strongswan-5.2.0/conf/Makefile.am
@@ -8,83 +8,21 @@ optionstemplatedir = $(templatesdir)/strongswan.d
 pluginstemplatedir = $(templatesdir)/plugins
 
 options = \
-	options/aikgen.opt \
-	options/attest.opt \
 	options/charon.opt \
 	options/charon-logging.opt \
-	options/imcv.opt \
-	options/manager.opt \
-	options/medsrv.opt \
-	options/pacman.opt \
-	options/pki.opt \
-	options/pool.opt \
-	options/scepclient.opt \
-	options/starter.opt \
-	options/swanctl.opt \
-	options/tnc.opt
+	options/starter.opt 
 
 plugins = \
-	plugins/android_log.opt \
 	plugins/attr.opt \
-	plugins/attr-sql.opt \
-	plugins/certexpire.opt \
-	plugins/coupling.opt \
 	plugins/dhcp.opt \
-	plugins/dnscert.opt \
-	plugins/duplicheck.opt \
-	plugins/eap-aka.opt \
-	plugins/eap-aka-3ggp2.opt \
-	plugins/eap-dynamic.opt \
-	plugins/eap-gtc.opt \
-	plugins/eap-peap.opt \
-	plugins/eap-radius.opt \
-	plugins/eap-sim.opt \
-	plugins/eap-simaka-sql.opt \
-	plugins/eap-tls.opt \
-	plugins/eap-tnc.opt \
-	plugins/eap-ttls.opt \
-	plugins/error-notify.opt \
-	plugins/gcrypt.opt \
-	plugins/ha.opt \
-	plugins/imc-attestation.opt \
-	plugins/imc-os.opt \
-	plugins/imc-scanner.opt \
-	plugins/imc-swid.opt \
-	plugins/imc-test.opt \
-	plugins/imv-attestation.opt \
-	plugins/imv-os.opt \
-	plugins/imv-scanner.opt \
-	plugins/imv-swid.opt \
-	plugins/imv-test.opt \
-	plugins/ipseckey.opt \
-	plugins/led.opt \
 	plugins/kernel-libipsec.opt \
 	plugins/kernel-netlink.opt \
-	plugins/kernel-pfroute.opt \
-	plugins/load-tester.opt \
-	plugins/lookip.opt \
-	plugins/ntru.opt \
 	plugins/openssl.opt \
-	plugins/pkcs11.opt \
-	plugins/radattr.opt \
 	plugins/random.opt \
 	plugins/resolve.opt \
 	plugins/socket-default.opt \
-	plugins/sql.opt \
 	plugins/stroke.opt \
-	plugins/systime-fix.opt \
-	plugins/tnc-ifmap.opt \
-	plugins/tnc-imc.opt \
-	plugins/tnc-imv.opt \
-	plugins/tnc-pdp.opt \
-	plugins/tnccs-11.opt \
-	plugins/tnccs-20.opt \
-	plugins/unbound.opt \
-	plugins/updown.opt \
-	plugins/vici.opt \
-	plugins/whitelist.opt \
-	plugins/xauth-eap.opt \
-	plugins/xauth-pam.opt
+	plugins/updown.opt
 
 alloptions = $(options) $(plugins)
 
diff --git a/strongswan-5.2.0/conf/plugins/kernel-libipsec.opt b/strongswan-5.2.0/conf/plugins/kernel-libipsec.opt
index e76db63..31c69af 100644
--- a/strongswan-5.2.0/conf/plugins/kernel-libipsec.opt
+++ b/strongswan-5.2.0/conf/plugins/kernel-libipsec.opt
@@ -1,4 +1,8 @@
-charon.plugins.kernel-libipsec.allow_peer_ts = no
+charon.plugins.kernel-libipsec.load = yes
+	Whether to load the plugin. Can also be an integer to increase the
+    priority of this plugin.
+
+charon.plugins.kernel-libipsec.allow_peer_ts = yes
 	Allow that the remote traffic selector equals the IKE peer.
 
 	Allow that the remote traffic selector equals the IKE peer. The route
diff --git a/strongswan-5.2.0/conf/plugins/kernel-netlink.opt b/strongswan-5.2.0/conf/plugins/kernel-netlink.opt
index a8e421b..1d6e5c3 100644
--- a/strongswan-5.2.0/conf/plugins/kernel-netlink.opt
+++ b/strongswan-5.2.0/conf/plugins/kernel-netlink.opt
@@ -1,4 +1,4 @@
-charon.plugins.kernel-netlink.fwmark =
+charon.plugins.kernel-netlink.fwmark = !0x42
 	Firewall mark to set on the routing rule that directs traffic to our routing
 	table.
 
diff --git a/strongswan-5.2.0/conf/plugins/socket-default.opt b/strongswan-5.2.0/conf/plugins/socket-default.opt
index 483a0f0..e4f8133 100644
--- a/strongswan-5.2.0/conf/plugins/socket-default.opt
+++ b/strongswan-5.2.0/conf/plugins/socket-default.opt
@@ -1,4 +1,4 @@
-charon.plugins.socket-default.fwmark =
+charon.plugins.socket-default.fwmark = 0x42
 	Firewall mark to set on outbound packets.
 
 charon.plugins.socket-default.set_source = yes
diff --git a/strongswan-5.2.0/configure.ac b/strongswan-5.2.0/configure.ac
index 8f4d763..b84fce1 100644
--- a/strongswan-5.2.0/configure.ac
+++ b/strongswan-5.2.0/configure.ac
@@ -13,13 +13,34 @@
 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
-#
-
+# 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */  
+ 
 # ============================
 #  initialize & set some vars
 # ============================
 
-AC_INIT([strongSwan],[5.2.0])
+AC_INIT([strongSwanCont],[5.2.0])
 AM_INIT_AUTOMAKE(m4_esyscmd([
 	echo tar-ustar
 	echo subdir-objects
@@ -55,15 +76,10 @@ ARG_WITH_SUBST([ipsecdir],           [${libexecdir%/}/ipsec], [set installation
 ARG_WITH_SUBST([ipseclibdir],        [${libdir%/}/ipsec], [set installation path for ipsec libraries])
 ARG_WITH_SUBST([plugindir],          [${ipseclibdir%/}/plugins], [set the installation path of plugins])
 ARG_WITH_SUBST([imcvdir],            [${ipseclibdir%/}/imcvs], [set the installation path of IMC and IMV dynamic librariers])
-ARG_WITH_SUBST([nm-ca-dir],          [/usr/share/ca-certificates], [directory the NM backend uses to look up trusted root certificates])
-ARG_WITH_SUBST([swanctldir],         [${sysconfdir}/swanctl], [base directory for swanctl configuration files and credentials])
 ARG_WITH_SUBST([linux-headers],      [\${top_srcdir}/src/include], [set directory of linux header files to use])
 ARG_WITH_SUBST([routing-table],      [220], [set routing table to use for IPsec routes])
 ARG_WITH_SUBST([routing-table-prio], [220], [set priority for IPsec routing table])
 ARG_WITH_SUBST([ipsec-script],       [ipsec], [change the name of the ipsec script])
-ARG_WITH_SUBST([fips-mode],          [0], [set openssl FIPS mode: disabled(0), enabled(1), Suite B enabled(2)])
-
-ARG_WITH_SET([tss],                  [no], [set implementation of the Trusted Computing Group's Software Stack (TSS). Currently the only supported value is "trousers"])
 ARG_WITH_SET([capabilities],         [no], [set capability dropping library. Currently supported values are "libcap" and "native"])
 ARG_WITH_SET([mpz_powm_sec],         [yes], [use the more side-channel resistant mpz_powm_sec in libgmp, if available])
 ARG_WITH_SET([dev-headers],          [no], [install strongSwan development headers to directory.])
@@ -122,170 +138,44 @@ m4_include(m4/macros/enable-disable.m4)
 
 # crypto plugins
 ARG_DISBL_SET([aes],            [disable AES software implementation plugin.])
-ARG_ENABL_SET([af-alg],         [enable AF_ALG crypto interface to Linux Crypto API.])
-ARG_ENABL_SET([blowfish],       [enable Blowfish software implementation plugin.])
-ARG_ENABL_SET([ccm],            [enables the CCM AEAD wrapper crypto plugin.])
-ARG_DISBL_SET([cmac],           [disable CMAC crypto implementation plugin.])
-ARG_ENABL_SET([ctr],            [enables the Counter Mode wrapper crypto plugin.])
-ARG_DISBL_SET([des],            [disable DES/3DES software implementation plugin.])
-ARG_DISBL_SET([fips-prf],       [disable FIPS PRF software implementation plugin.])
-ARG_ENABL_SET([gcm],            [enables the GCM AEAD wrapper crypto plugin.])
-ARG_ENABL_SET([gcrypt],         [enables the libgcrypt plugin.])
+ARG_DISBL_SET([contactcrypto],  [disable ContactCrypto software implementation plugin.])
 ARG_DISBL_SET([gmp],            [disable GNU MP (libgmp) based crypto implementation plugin.])
 ARG_DISBL_SET([hmac],           [disable HMAC crypto implementation plugin.])
-ARG_ENABL_SET([md4],            [enable MD4 software implementation plugin.])
-ARG_DISBL_SET([md5],            [disable MD5 software implementation plugin.])
 ARG_DISBL_SET([nonce],          [disable nonce generation plugin.])
-ARG_ENABL_SET([ntru],           [enables the NTRU crypto plugin.])
-ARG_ENABL_SET([openssl],        [enables the OpenSSL crypto plugin.])
-ARG_ENABL_SET([padlock],        [enables VIA Padlock crypto plugin.])
 ARG_DISBL_SET([random],         [disable RNG implementation on top of /dev/(u)random.])
-ARG_DISBL_SET([rc2],            [disable RC2 software implementation plugin.])
-ARG_ENABL_SET([rdrand],         [enable Intel RDRAND random generator plugin.])
 ARG_DISBL_SET([sha1],           [disable SHA1 software implementation plugin.])
-ARG_DISBL_SET([sha2],           [disable SHA256/SHA384/SHA512 software implementation plugin.])
-ARG_DISBL_SET([xcbc],           [disable xcbc crypto implementation plugin.])
 # encoding/decoding plugins
-ARG_DISBL_SET([dnskey],         [disable DNS RR key decoding plugin.])
+ARG_DISBL_SET([usbbar],         [disable USBBAR private key plugin.])
 ARG_DISBL_SET([pem],            [disable PEM decoding plugin.])
-ARG_DISBL_SET([pgp],            [disable PGP key decoding plugin.])
-ARG_DISBL_SET([pkcs1],          [disable PKCS1 key decoding plugin.])
-ARG_DISBL_SET([pkcs7],          [disable PKCS7 container support plugin.])
-ARG_DISBL_SET([pkcs8],          [disable PKCS8 private key decoding plugin.])
-ARG_DISBL_SET([pkcs12],         [disable PKCS12 container support plugin.])
 ARG_DISBL_SET([pubkey],         [disable RAW public key support plugin.])
-ARG_DISBL_SET([sshkey],         [disable SSH key decoding plugin.])
 ARG_DISBL_SET([x509],           [disable X509 certificate implementation plugin.])
-# fetcher/resolver plugins
-ARG_ENABL_SET([curl],           [enable CURL fetcher plugin to fetch files via libcurl. Requires libcurl.])
-ARG_ENABL_SET([ldap],           [enable LDAP fetching plugin to fetch files via libldap. Requires openLDAP.])
-ARG_ENABL_SET([soup],           [enable soup fetcher plugin to fetch from HTTP via libsoup. Requires libsoup.])
-ARG_ENABL_SET([unbound],        [enable UNBOUND resolver plugin to perform DNS queries via libunbound. Requires libldns and libunbound.])
-ARG_ENABL_SET([winhttp],        [enable WinHTTP based HTTP/HTTPS fetching plugin.])
-# database plugins
-ARG_ENABL_SET([mysql],          [enable MySQL database support. Requires libmysqlclient_r.])
-ARG_ENABL_SET([sqlite],         [enable SQLite database support. Requires libsqlite3.])
 # authentication/credential plugins
-ARG_ENABL_SET([addrblock],      [enables RFC 3779 address block constraint support.])
-ARG_ENABL_SET([acert],          [enable X509 attribute certificate checking plugin.])
-ARG_ENABL_SET([agent],          [enables the ssh-agent signing plugin.])
 ARG_DISBL_SET([constraints],    [disable advanced X509 constraint checking plugin.])
-ARG_ENABL_SET([coupling],       [enable IKEv2 plugin to couple peer certificates permanently to authentication.])
-ARG_ENABL_SET([dnscert],        [enable DNSCERT authentication plugin.])
-ARG_ENABL_SET([eap-sim],        [enable SIM authentication module for EAP.])
-ARG_ENABL_SET([eap-sim-file],   [enable EAP-SIM backend based on a triplet file.])
-ARG_ENABL_SET([eap-sim-pcsc],   [enable EAP-SIM backend based on a smartcard reader. Requires libpcsclite.])
-ARG_ENABL_SET([eap-aka],        [enable EAP AKA authentication module.])
-ARG_ENABL_SET([eap-aka-3gpp2],  [enable EAP AKA backend implementing 3GPP2 algorithms in software. Requires libgmp.])
-ARG_ENABL_SET([eap-simaka-sql], [enable EAP-SIM/AKA backend based on a triplet/quintuplet SQL database.])
-ARG_ENABL_SET([eap-simaka-pseudonym], [enable EAP-SIM/AKA pseudonym storage plugin.])
-ARG_ENABL_SET([eap-simaka-reauth],    [enable EAP-SIM/AKA reauthentication data storage plugin.])
-ARG_ENABL_SET([eap-identity],   [enable EAP module providing EAP-Identity helper.])
-ARG_ENABL_SET([eap-md5],        [enable EAP MD5 (CHAP) authentication module.])
-ARG_ENABL_SET([eap-gtc],        [enable EAP GTC authentication module.])
-ARG_ENABL_SET([eap-mschapv2],   [enable EAP MS-CHAPv2 authentication module.])
-ARG_ENABL_SET([eap-tls],        [enable EAP TLS authentication module.])
-ARG_ENABL_SET([eap-ttls],       [enable EAP TTLS authentication module.])
-ARG_ENABL_SET([eap-peap],       [enable EAP PEAP authentication module.])
-ARG_ENABL_SET([eap-tnc],        [enable EAP TNC trusted network connect module.])
-ARG_ENABL_SET([eap-dynamic],    [enable dynamic EAP proxy module.])
-ARG_ENABL_SET([eap-radius],     [enable RADIUS proxy authentication module.])
-ARG_ENABL_SET([ipseckey],       [enable IPSECKEY authentication plugin.])
-ARG_ENABL_SET([keychain],       [enables OS X Keychain Services credential set.])
-ARG_ENABL_SET([pkcs11],         [enables the PKCS11 token support plugin.])
+ARG_DISBL_SET([eap-bsts],       [enable BSTS authentication module for EAP.])
 ARG_DISBL_SET([revocation],     [disable X509 CRL/OCSP revocation check plugin.])
-ARG_ENABL_SET([whitelist],      [enable peer identity whitelisting plugin.])
-ARG_DISBL_SET([xauth-generic],  [disable generic XAuth backend.])
-ARG_ENABL_SET([xauth-eap],      [enable XAuth backend using EAP methods to verify passwords.])
-ARG_ENABL_SET([xauth-pam],      [enable XAuth backend using PAM to verify passwords.])
-ARG_ENABL_SET([xauth-noauth],   [enable XAuth pseudo-backend that does not actually verify or even request any credentials.])
 # kernel interfaces / sockets
 ARG_DISBL_SET([kernel-netlink], [disable the netlink kernel interface.])
-ARG_ENABL_SET([kernel-pfkey],   [enable the PF_KEY kernel interface.])
-ARG_ENABL_SET([kernel-pfroute], [enable the PF_ROUTE kernel interface.])
-ARG_ENABL_SET([kernel-iph],     [enable the Windows IP Helper based networking backend.])
-ARG_ENABL_SET([kernel-libipsec],[enable the libipsec kernel interface.])
-ARG_ENABL_SET([kernel-wfp],     [enable the Windows Filtering Platform IPsec backend.])
+ARG_DISBL_SET([kernel-libipsec],[disable the libipsec kernel interface.])
 ARG_DISBL_SET([socket-default], [disable default socket implementation for charon.])
-ARG_ENABL_SET([socket-dynamic], [enable dynamic socket implementation for charon])
-ARG_ENABL_SET([socket-win],     [enable Winsock2 based socket implementation for charon])
 # configuration/control plugins
 ARG_DISBL_SET([stroke],         [disable charons stroke configuration backend.])
-ARG_ENABL_SET([smp],            [enable SMP configuration and control interface. Requires libxml.])
-ARG_ENABL_SET([sql],            [enable SQL database configuration backend.])
-ARG_ENABL_SET([uci],            [enable OpenWRT UCI configuration plugin.])
-ARG_ENABL_SET([vici],           [enable strongSwan IKE generic IPC interface plugin.])
 # attribute provider/consumer plugins
-ARG_ENABL_SET([android-dns],    [enable Android specific DNS handler.])
 ARG_DISBL_SET([attr],           [disable strongswan.conf based configuration attribute plugin.])
-ARG_ENABL_SET([attr-sql],       [enable SQL based configuration attribute plugin.])
-ARG_ENABL_SET([dhcp],           [enable DHCP based attribute provider plugin.])
-ARG_ENABL_SET([osx-attr],       [enable OS X SystemConfiguration attribute handler.])
+ARG_DISBL_SET([dhcp],           [enable DHCP based attribute provider plugin.])
 ARG_DISBL_SET([resolve],        [disable resolve DNS handler plugin.])
-ARG_ENABL_SET([unity],          [enables Cisco Unity extension plugin.])
-# TNC modules/plugins
-ARG_ENABL_SET([imc-test],       [enable IMC test module.])
-ARG_ENABL_SET([imv-test],       [enable IMV test module.])
-ARG_ENABL_SET([imc-scanner],    [enable IMC port scanner module.])
-ARG_ENABL_SET([imv-scanner],    [enable IMV port scanner module.])
-ARG_ENABL_SET([imc-os],         [enable IMC operating system module.])
-ARG_ENABL_SET([imv-os],         [enable IMV operating system module.])
-ARG_ENABL_SET([imc-attestation],[enable IMC attestation module.])
-ARG_ENABL_SET([imv-attestation],[enable IMV attestation module.])
-ARG_ENABL_SET([imc-swid],       [enable IMC swid module.])
-ARG_ENABL_SET([imv-swid],       [enable IMV swid module.])
-ARG_ENABL_SET([tnc-ifmap],      [enable TNC IF-MAP module. Requires libxml])
-ARG_ENABL_SET([tnc-imc],        [enable TNC IMC module.])
-ARG_ENABL_SET([tnc-imv],        [enable TNC IMV module.])
-ARG_ENABL_SET([tnc-pdp],        [enable TNC policy decision point module.])
-ARG_ENABL_SET([tnccs-11],       [enable TNCCS 1.1 protocol module. Requires libxml])
-ARG_ENABL_SET([tnccs-20],       [enable TNCCS 2.0 protocol module.])
-ARG_ENABL_SET([tnccs-dynamic],  [enable dynamic TNCCS protocol discovery module.])
 # misc plugins
-ARG_ENABL_SET([android-log],    [enable Android specific logger plugin.])
-ARG_ENABL_SET([certexpire],     [enable CSV export of expiration dates of used certificates.])
-ARG_ENABL_SET([duplicheck],     [advanced duplicate checking plugin using liveness checks.])
-ARG_ENABL_SET([error-notify],   [enable error notification plugin.])
-ARG_ENABL_SET([farp],           [enable ARP faking plugin that responds to ARP requests to peers virtual IP])
-ARG_ENABL_SET([ha],             [enable high availability cluster plugin.])
-ARG_ENABL_SET([led],            [enable plugin to control LEDs on IKEv2 activity using the Linux kernel LED subsystem.])
-ARG_ENABL_SET([load-tester],    [enable load testing plugin for IKEv2 daemon.])
-ARG_ENABL_SET([lookip],         [enable fast virtual IP lookup and notification plugin.])
-ARG_ENABL_SET([maemo],          [enable Maemo specific plugin.])
-ARG_ENABL_SET([radattr],        [enable plugin to inject and process custom RADIUS attributes as IKEv2 client.])
-ARG_ENABL_SET([systime-fix],    [enable plugin to handle cert lifetimes with invalid system time gracefully.])
-ARG_ENABL_SET([test-vectors],   [enable plugin providing crypto test vectors.])
-ARG_ENABL_SET([unit-tester],    [enable unit tests on IKEv2 daemon startup.])
 ARG_DISBL_SET([updown],         [disable updown firewall script plugin.])
 # programs/components
-ARG_ENABL_SET([aikgen],         [enable AIK generator.])
 ARG_DISBL_SET([charon],         [disable the IKEv1/IKEv2 keying daemon charon.])
-ARG_ENABL_SET([cmd],            [enable the command line IKE client charon-cmd.])
-ARG_ENABL_SET([conftest],       [enforce Suite B conformance test framework.])
-ARG_ENABL_SET([dumm],           [enable the DUMM UML test framework.])
-ARG_ENABL_SET([fast],           [enable libfast (FastCGI Application Server w/ templates.])
 ARG_ENABL_SET([libipsec],       [enable user space IPsec implementation.])
-ARG_ENABL_SET([manager],        [enable web management console (proof of concept).])
-ARG_ENABL_SET([medcli],         [enable mediation client configuration database plugin.])
-ARG_ENABL_SET([medsrv],         [enable mediation server web frontend and daemon plugin.])
-ARG_ENABL_SET([nm],             [enable NetworkManager backend.])
-ARG_DISBL_SET([pki],            [disable pki certificate utility.])
-ARG_DISBL_SET([scepclient],     [disable SCEP client tool.])
 ARG_DISBL_SET([scripts],        [disable additional utilities (found in directory scripts).])
-ARG_ENABL_SET([svc],            [enable charon Windows service.])
-ARG_ENABL_SET([swanctl],        [enable swanctl configuration and control tool.])
-ARG_ENABL_SET([tkm],            [enable Trusted Key Manager support.])
 # optional features
-ARG_ENABL_SET([bfd-backtraces], [use binutils libbfd to resolve backtraces for memory leaks and segfaults.])
-ARG_ENABL_SET([dbghelp-backtraces],[use dbghlp.dll on Windows to create and print backtraces for memory leaks and segfaults.])
-ARG_DISBL_SET([ikev1],          [disable IKEv1 protocol support in charon.])
+ARG_ENABL_SET([ikev1],          [disable IKEv1 protocol support in charon.])
 ARG_DISBL_SET([ikev2],          [disable IKEv2 protocol support in charon.])
 ARG_ENABL_SET([integrity-test], [enable integrity testing of libstrongswan and plugins.])
 ARG_DISBL_SET([load-warning],   [disable the charon plugin load option warning in starter.])
 ARG_ENABL_SET([mediation],      [enable IKEv2 Mediation Extension.])
-ARG_ENABL_SET([unwind-backtraces],[use libunwind to create backtraces for memory leaks and segfaults.])
 # compile options
-ARG_ENABL_SET([coverage],       [enable lcov coverage report generation.])
 ARG_ENABL_SET([leak-detective], [enable malloc hooks to find memory leaks.])
 ARG_ENABL_SET([lock-profiler],  [enable lock/mutex profiling code.])
 ARG_ENABL_SET([monolithic],     [build monolithic version of libstrongswan that includes all enabled plugins. Similarly, the plugins of charon are assembled in libcharon.])
@@ -320,10 +210,13 @@ fi
 #  set up compiler and flags
 # ===========================
 
+AC_LANG_PUSH(C++)
+CC = gcc
 if test -z "$CFLAGS"; then
 	CFLAGS="-g -O2 -Wall -Wno-format -Wno-format-security -Wno-pointer-sign"
 fi
-AC_PROG_CC
+AC_PROG_CC([gcc])
+AC_PROG_CXX([gcc])
 AM_PROG_CC_C_O
 
 AC_LIB_PREFIX
@@ -359,75 +252,10 @@ fi
 #  dependency calculation
 # ========================
 
-if test x$xauth_generic_given = xfalse -a x$ikev1 = xfalse; then
-	xauth_generic=false;
-fi
-
 if test x$kernel_libipsec = xtrue; then
 	libipsec=true;
 fi
 
-if test x$eap_aka_3gpp2 = xtrue; then
-	gmp=true;
-fi
-
-if test x$eap_aka = xtrue; then
-	fips_prf=true;
-	simaka=true;
-fi
-
-if test x$eap_sim = xtrue; then
-	fips_prf=true;
-	simaka=true;
-fi
-
-if test x$eap_radius = xtrue -o x$radattr = xtrue -o x$tnc_pdp = xtrue; then
-	radius=true;
-fi
-
-if test x$tnc_imc = xtrue -o x$tnc_imv = xtrue -o x$tnccs_11 = xtrue -o x$tnccs_11 = xtrue -o x$tnccs_dynamic = xtrue -o x$eap_tnc = xtrue; then
-	tnc_tnccs=true;
-fi
-
-if test x$eap_tls = xtrue -o x$eap_ttls = xtrue -o x$eap_peap = xtrue -o x$tnc_tnccs = xtrue; then
-	tls=true;
-fi
-
-if test x$imc_test = xtrue -o x$imv_test = xtrue -o x$imc_scanner = xtrue -o x$imv_scanner = xtrue -o x$imc_os = xtrue -o x$imv_os = xtrue -o x$imc_attestation = xtrue -o x$imv_attestation = xtrue -o x$imc_swid = xtrue -o x$imv_swid = xtrue; then
-	imcv=true;
-fi
-
-if test x$imc_attestation = xtrue -o x$imv_attestation = xtrue -o x$imc_swid = xtrue -o x$imv_swid = xtrue; then
-	pts=true;
-fi
-
-if test x$fips_prf = xtrue; then
-	if test x$openssl = xfalse; then
-		sha1=true;
-	fi
-fi
-
-if test x$swanctl = xtrue; then
-	vici=true
-fi
-
-if test x$smp = xtrue -o x$tnccs_11 = xtrue -o x$tnc_ifmap = xtrue; then
-	xml=true
-fi
-
-if test x$manager = xtrue; then
-	fast=true
-fi
-
-if test x$medsrv = xtrue; then
-	mediation=true
-	fast=true
-fi
-
-if test x$medcli = xtrue; then
-	mediation=true
-fi
-
 # ===========================================
 #  check required libraries and header files
 # ===========================================
@@ -869,82 +697,11 @@ if test x$xml = xtrue; then
 	AC_SUBST(xml_LIBS)
 fi
 
-if test x$tss = xtrousers; then
-	AC_CHECK_LIB([tspi],[main],[LIBS="$LIBS"],[AC_MSG_ERROR([TrouSerS library libtspi not found])],[])
-	AC_CHECK_HEADER([trousers/tss.h],,[AC_MSG_ERROR([TrouSerS header trousers/tss.h not found!])])
-	AC_DEFINE([TSS_TROUSERS], [], [use TrouSerS library libtspi as TSS implementation])
-fi
-
 if test x$imv_swid = xtrue; then
 	AC_CHECK_LIB([json],[main],[LIBS="$LIBS"],[AC_MSG_ERROR([JSON library libjson not found])],[])
 	AC_CHECK_HEADER([json/json.h],,[AC_MSG_ERROR([JSON header json/json.h not found!])])
 fi
 
-if test x$dumm = xtrue; then
-	PKG_CHECK_MODULES(gtk, [gtk+-2.0 vte])
-	AC_SUBST(gtk_CFLAGS)
-	AC_SUBST(gtk_LIBS)
-	AC_CHECK_PROGS(RUBY, ruby)
-	AC_MSG_CHECKING([for Ruby header files])
-	if test -n "$RUBY"; then
-		RUBYINCLUDE=
-		RUBYDIR=`($RUBY -r rbconfig -e 'print RbConfig::CONFIG[["rubyhdrdir"]] || ""') 2>/dev/null`
-		if test -n "$RUBYDIR" -a -r "$RUBYDIR/ruby.h"; then
-			RUBYARCH=`($RUBY -r rbconfig -e 'print RbConfig::CONFIG[["arch"]] || ""') 2>/dev/null`
-			if test -n "$RUBYARCH"; then
-				AC_MSG_RESULT([$RUBYDIR])
-				RUBYINCLUDE="-I$RUBYDIR -I$RUBYDIR/$RUBYARCH"
-			fi
-		else
-			RUBYDIR=`($RUBY -r rbconfig -e 'print RbConfig::CONFIG[["archdir"]] || ""') 2>/dev/null`
-			if test -n "$RUBYDIR" -a -r "$RUBYDIR/ruby.h"; then
-				AC_MSG_RESULT([$RUBYDIR])
-				RUBYINCLUDE="-I$RUBYDIR"
-			fi
-		fi
-		if test -z "$RUBYINCLUDE"; then
-			AC_MSG_ERROR([ruby.h not found])
-		fi
-		AC_SUBST(RUBYINCLUDE)
-	else
-		AC_MSG_ERROR([don't know how to run ruby])
-	fi
-	AC_MSG_CHECKING([for libruby])
-	saved_LIBS=$LIBS
-	LIBS=`($RUBY -r rbconfig -e 'print RbConfig::CONFIG[["LIBRUBYARG_SHARED"]] || ""') 2>/dev/null`
-	AC_TRY_LINK_FUNC(ruby_init,
-		[AC_MSG_RESULT([$LIBS]); RUBYLIB=$LIBS],
-		[AC_MSG_ERROR([not found])])
-	AC_SUBST(RUBYLIB)
-	AC_CHECK_FUNCS(rb_errinfo)
-	LIBS=$saved_LIBS
-fi
-
-if test x$fast = xtrue; then
-	AC_CHECK_LIB([neo_cgi],[main],[LIBS="$LIBS"],[AC_MSG_ERROR([ClearSilver library neo_cgi not found!])],[])
-	AC_CHECK_LIB([neo_utl],[main],[LIBS="$LIBS"],[AC_MSG_ERROR([ClearSilver library neo_utl not found!])],[])
-	AC_MSG_CHECKING([ClearSilver requires zlib])
-	saved_CFLAGS=$CFLAGS
-	saved_LIBS=$LIBS
-	LIBS="-lneo_cgi -lneo_cs -lneo_utl"
-	CFLAGS="-I/usr/include/ClearSilver"
-	AC_LINK_IFELSE(
-		[AC_LANG_PROGRAM(
-			[[#include <ClearSilver.h>]],
-			[[NEOERR *err = cgi_display(NULL, NULL);]])],
-		[AC_MSG_RESULT([no]); clearsilver_LIBS="$LIBS"],
-		[AC_MSG_RESULT([yes]); clearsilver_LIBS="$LIBS -lz"]
-	)
-	AC_SUBST(clearsilver_LIBS)
-	LIBS=$saved_LIBS
-	CFLAGS=$saved_CFLAGS
-# autoconf does not like CamelCase!? How to fix this?
-#	AC_CHECK_HEADER([ClearSilver/ClearSilver.h],,[AC_MSG_ERROR([ClearSilver header file ClearSilver/ClearSilver.h not found!])])
-
-	AC_CHECK_LIB([fcgi],[main],[LIBS="$LIBS"],[AC_MSG_ERROR([FastCGI library fcgi not found!])],[])
-	AC_CHECK_HEADER([fcgiapp.h],,[AC_MSG_ERROR([FastCGI header file fcgiapp.h not found!])])
-fi
-
 if test x$mysql = xtrue; then
 	if test "x$windows" = xtrue; then
 		AC_CHECK_HEADER([mysql.h],,[AC_MSG_ERROR([MySQL header file mysql.h not found!])])
@@ -985,11 +742,6 @@ if test x$sqlite = xtrue; then
 	)
 fi
 
-if test x$openssl = xtrue; then
-	AC_CHECK_LIB([$openssl_lib],[main],[LIBS="$LIBS"],[AC_MSG_ERROR([OpenSSL lib$openssl_lib not found])],[])
-	AC_CHECK_HEADER([openssl/evp.h],,[AC_MSG_ERROR([OpenSSL header openssl/evp.h not found!])])
-fi
-
 if test x$gcrypt = xtrue; then
 	AC_CHECK_LIB([gcrypt],[main],[LIBS="$LIBS"],[AC_MSG_ERROR([gcrypt library not found])],[-lgpg-error])
 	AC_CHECK_HEADER([gcrypt.h],,[AC_MSG_ERROR([gcrypt header gcrypt.h not found!])])
@@ -1032,15 +784,6 @@ if test x$eap_sim_pcsc = xtrue; then
 	AC_SUBST(pcsclite_LIBS)
 fi
 
-if test x$nm = xtrue; then
-	PKG_CHECK_EXISTS([libnm-glib],
-		[PKG_CHECK_MODULES(nm, [NetworkManager gthread-2.0 libnm-util libnm-glib libnm-glib-vpn])],
-		[PKG_CHECK_MODULES(nm, [NetworkManager gthread-2.0 libnm_util libnm_glib libnm_glib_vpn])]
-	)
-	AC_SUBST(nm_CFLAGS)
-	AC_SUBST(nm_LIBS)
-fi
-
 if test x$xauth_pam = xtrue; then
 	AC_CHECK_LIB([pam],[main],[LIBS="$LIBS"],[AC_MSG_ERROR([PAM library not found])],[])
 	AC_CHECK_HEADER([security/pam_appl.h],,[AC_MSG_ERROR([PAM header security/pam_appl.h not found!])])
@@ -1110,13 +853,6 @@ AC_SUBST(dev_headers)
 
 CFLAGS="$CFLAGS -include `pwd`/config.h"
 
-if test x$tkm = xtrue; then
-	AC_PATH_PROG([GPRBUILD], [gprbuild], [], [$PATH:/bin:/usr/bin:/usr/local/bin])
-	if test x$GPRBUILD = x; then
-		AC_MSG_ERROR([gprbuild not found])
-	fi
-fi
-
 if test x$coverage = xtrue; then
 	AC_PATH_PROG([LCOV], [lcov], [], [$PATH:/bin:/usr/bin:/usr/local/bin])
 	if test x$LCOV = x; then
